local name, addon = ...

local embed = addon['LibInit']("zzCommon-Base", 3, {'RegisterFunc','HandleFunclist','round','split','colorize','Print'})
if(type(embed) ~= 'function') then return end

local table = table
local string = string
local math = math
local type = type
local tostring = tostring
local lib = {
	['RegisterFunc'] = function(event,typ,func)
		local f = CreateFrame("Frame")
		if(type(event) == "table") then
			for i = 1, #event do
				f:RegisterEvent(event[i])
			end
		else
			f:RegisterEvent(event)
		end
		if(typ and type(func) == 'function') then
			f:SetScript(typ, func)
		end
		return f
	end,
	['HandleFunclist'] = function(lib, list)
		for _, v in ipairs(lib[list]) do
			v()
		end
	end,
	['split'] = function(s, delim)
--		assert (type (delim) == "string" and string.len (delim) > 0, "bad delimiter")
		local start = 1
		local t = {}
		while true do
			local pos = string.find (s, delim, start, true)
			if not pos then	break end
			table.insert (t, string.sub (s, start, pos - 1))
			start = pos + string.len (delim)
		end
		table.insert (t, string.sub (s, start))
		return t
	end,
	['round'] = function(num, idp)
		return math.floor(num * (10^(idp or 0)) + 0.5) / (10^(idp or 0))
	end,
	['colorize'] = function(text,color)
		return string.format("|cff%s%s|r",color,text)
	end,
	['Print'] = function(message)
		SELECTED_CHAT_FRAME:AddMessage(tostring(message))
	end
}
embed(lib)