local name, addon = ...
addon['aura'] = addon['aura'] or {}
addon['auraplugs'] = addon['auraplugs'] or {}
addon['AuraIsUp']=addon['AuraIsUp'] or {}

local guids = {}
local auras = {}
local unitlist = {
	['player'] = true,
	['target'] = true,
	['focus'] = true,
}
local register = {
}
local BUFF_MAX_DISPLAY = BUFF_MAX_DISPLAY
local UnitAura = UnitAura
local UnitGUID = UnitGUID
local pairs = pairs

local function uniqueRegName(guid)
	local n = 1
	while(register[guid]['regName'..n]) do
		n = n + 1
	end
	return 'regName'..n
end

addon['registerAuraUpdate'] = function(guid , func, regname)
	register[guid] = register[guid] or {}
	regname = regname or uniqueRegName(guid)
	register[guid][regname] = func
	return regname
end

local function CheckUnitExist(unit)
	if(UnitExists(unit)) then
		guids[UnitGUID(unit)] = true
	end
end

local function getGUIDList()
	wipe(guids)
	for unit in pairs(unitlist) do
		CheckUnitExist(unit)
	end
	return guids
end

local function publishAuraUpdate(guid)
	if(not getGUIDList()[guid]) then
		register[guid] = nil
		return
	end
	for unit, tab in pairs(register) do
		if(guid == unit)then
			for regName, func in pairs(tab) do
				func(guid, auras[guid], regName)
--				print("a", auras[guid][1][4])
			end
			break
		end
	end
end

local function scanAura(unit)
-- name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3
	local guid = UnitGUID(unit)
	if(not guid) then return end
	auras[guid] = auras[guid] or {}
	wipe(auras[guid])
	for i=1,BUFF_MAX_DISPLAY do
		auras[guid][#auras[guid] + 1] = {UnitAura(unit,i,"HELPFUL")}
		if(not auras[guid][#auras[guid]][1]) then
			auras[guid][#auras[guid]] = nil
			break
		else
			auras[guid][#auras[guid]][#auras[guid][#auras[guid]] + 1] = "HELPFUL"
			auras[guid][#auras[guid]][#auras[guid][#auras[guid]] + 1] = i
			auras[guid][#auras[guid]][#auras[guid][#auras[guid]] + 1] = unit
		end
	end
	for i=1,BUFF_MAX_DISPLAY do
		auras[guid][#auras[guid] + 1] = {UnitAura(unit,i,"HARMFUL")}
		if(not auras[guid][#auras[guid]][1]) then
			auras[guid][#auras[guid]] = nil
			break
		else
			auras[guid][#auras[guid]][#auras[guid][#auras[guid]] + 1] = "HARMFUL"
			auras[guid][#auras[guid]][#auras[guid][#auras[guid]] + 1] = i
			auras[guid][#auras[guid]][#auras[guid][#auras[guid]] + 1] = unit
		end
	end
	if(unit == 'player') then
		for i=1,#addon['auraplugs'] do
			addon['auraplugs'][i](auras)
		end
	end
	publishAuraUpdate(guid)
end
addon['scanAura'] = scanAura

local function purgeauralist()
	for guid in pairs(auras) do
		if(not getGUIDList()[guid]) then
			auras[guid] = nil
			register[guid] = nil
		end
	end
end

local function auraCheck(self, event, unit)
	if(event == "UNIT_AURA") then
		if(getGUIDList()[UnitGUID(unit)]) then
			if(unit=='target' and UnitIsUnit('player', 'target')) then return end
			if(unit=='focus' and (UnitIsUnit('focus', 'target') or UnitIsUnit('focus', 'player'))) then return end
			if(not unitlist[unit]) then return end
			scanAura(unit)
		end
	elseif(event == "PLAYER_TARGET_CHANGED") then
		if(UnitIsUnit('player', 'target')) then return end
		scanAura('target')
	elseif(event == "PLAYER_FOCUS_CHANGED") then
		if(UnitIsUnit('focus', 'target') or UnitIsUnit('focus', 'player')) then return end
		scanAura('focus')
	elseif(event == "PLAYER_REGEN_ENABLED") then
		purgeauralist()
		auraCheck(self, "PLAYER_ENTERING_WORLD")
	elseif(event == "PLAYER_REGEN_DISABLED") then
		
	elseif(event == "PLAYER_ENTERING_WORLD") then
		self:UnregisterEvent(event)
		for unit in pairs(unitlist) do
			auraCheck(self, "UNIT_AURA", unit)
		end
	end
end
local ef = addon['RegisterFunc']({"UNIT_AURA","PLAYER_ENTERING_WORLD","PLAYER_REGEN_ENABLED","PLAYER_REGEN_DISABLED"},"OnEvent",auraCheck)
addon['logouts'][#addon['logouts'] + 1] = function()
	ef:UnregisterAllEvents()
end
