local name, addon = ...
local power = 0
local watchclass = {
	['PALADIN'] = true,
	['ROGUE'] = true,
	['DRUID'] = true,
	['MONK'] = true,
	['WARLOCK'] = true,
}
local watchpower = {
	['HOLY_POWER'] = true,
	['SOUL_SHARDS'] = true,
}
addon['tooltips']['Charges'] = function(self)
	GameTooltip:AddDoubleLine("Sum", self['aura'][4])
end
function updateCharges(self, event, arg1, arg2)
	if(event == 'UNIT_POWER') then
		if(arg1 ~= 'player') then return end
		if(not watchpower[arg2]) then return end
	end
	power = 0
	if(addon['class'] == 'PALADIN') then
		power = UnitPower("player", 9)
	elseif(addon['class'] == 'WARLOCK') then
		power = UnitPower("player", 7)
	else
		power = GetComboPoints("player")
	end
	addon['scanAura']('player')
end
addon['sortbuttons']['Charges'] = function(a,b)
	if(a['aura'][11] == 'Charges') then return true end
	if(b['aura'][11] == 'Charges') then return false end
end
addon['inits'][#addon['inits'] + 1] = function ()
	if(not watchclass[addon['class']]) then return end
	addon['auraplugs'][#addon['auraplugs'] + 1] = function(auras)
		if(power>0) then
			auras[addon['pguid']][#auras[addon['pguid']] + 1] = {
				"Power","","Interface\\AddOns\\"..name.."\\Moduls\\combo\\a"..power..".tga",power,"",0,0,'player',false,false,"Charges",true,false,nil,nil,nil
			}
		end
		return auras
	end
	addon['RegisterFunc']({"UNIT_COMBO_POINTS","UNIT_POWER"},"OnEvent",updateCharges)
end

addon['AuraIsUp']['Charges'] = function()
	return power > 0
end