local name, addon = ...

local function tooltip(self,slot)
	GameTooltip:SetInventoryItem("player", slot)
end
addon['tooltips'] = {
	['MainHand'] = function(self)
		tooltip(self,16)
	end,
	['OffHand'] = function(self)
		tooltip(self,17)
	end,
	['Thrown'] = function(self)
		tooltip(self,18)
	end,
}
function updateWE(self, event, arg1)
	if(arg1 ~= 'player') then return end
	addon['scanAura']('player')
end
addon['sortbuttons']['MainHand'] = function(a,b)
	return a['aura'][7] > b['aura'][7]
end
addon['sortbuttons']['OffHand'] = function(a,b)
	return a['aura'][7] > b['aura'][7]
end
addon['sortbuttons']['Thrown'] = function(a,b)
	return a['aura'][7] > b['aura'][7]
end

local function checkDB(db, weName, expiration, charges, icon, auras)
	db[weName] = db[weName] or {
		['duration'] = expiration,
	}
	if(db[weName]['duration'] < expiration) then
		db[weName]['duration'] = expiration
	end
	auras[addon['pguid']][#auras[addon['pguid']] + 1] = {
		"Mainhand","",icon,charges,"",db[weName]['duration'], GetTime() + expiration,'player',false,false,weName,true,false,nil,nil,nil
	}
end

addon['inits'][#addon['inits'] + 1] = function ()
	addon['db']['profile']['spells'] = addon['db']['profile']['spells'] or {}
	local db = addon['db']['profile']['spells']
	addon['auraplugs'][#addon['auraplugs'] + 1] = function(auras)
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges, hasThrownEnchant, thrownExpiration, thrownCharges = GetWeaponEnchantInfo()
		if(hasMainHandEnchant) then
			checkDB(db, 'MainHand', mainHandExpiration/1000, mainHandCharges, GetInventoryItemTexture('player', 16), auras)
		end
		if(hasOffHandEnchant) then
			checkDB(db, 'OffHand', offHandExpiration/1000, offHandCharges, GetInventoryItemTexture('player', 17), auras)
		end
		if(hasThrownEnchant) then
			checkDB(db, 'Thrown', thrownExpiration/1000, thrownCharges, GetInventoryItemTexture('player', 18), auras)
		end
		return auras
	end
	addon['RegisterFunc']({"UNIT_INVENTORY_CHANGED"},"OnEvent",updateWE)
end

local function quick(i)
	return select(i, GetWeaponEnchantInfo())
end

addon['AuraIsUp']['Thrown'] = function()
	return quick(7)
end
addon['AuraIsUp']['OffHand'] = function()
	return quick(4)
end
addon['AuraIsUp']['MainHand'] = function()
	return quick(1)
end