local name, addon = ...
addon['barprefs'] = addon['barprefs'] or {}
local bars = {
	['Default'] = {
		['name'] = 'Default',
		['num'] = 0,
		['units'] = {
			['player'] = {
				['auras'] = {},
			},
			['target'] = {
				['auras'] = {},
			},
			['focus'] = {
				['auras'] = {},
			},
		},
		['spells'] = {},
		['whitelist'] = false,
	},
}
local UnitGUID = UnitGUID
local pairs = pairs
local tonumber = tonumber
local type = type
local newauras = {}
local found,db = nil, {}
local function barprefs() end -- dummy

local function barUpdate(bar)
	wipe(newauras)
	for unit, unitinfo in pairs(bar['units']) do
		if(not unitinfo['guid'] or unitinfo['guid'] ~= UnitGUID(unit)) then
			unitinfo['guid'] = UnitGUID(unit)
			wipe(unitinfo['auras'])
		end
		for aura, aurainfo in pairs(unitinfo['auras']) do
			if(not newauras[aura]) then
				newauras[aura] = aurainfo
			end
		end
	end
	for _, currentaura in pairs(bar['auras']) do
-- print("c",currentaura[1])
		found = true
		for _, aurainfo in pairs(newauras) do
--			print(currentaura[1],currentaura[11], aurainfo[11])
			if(currentaura[11] == aurainfo[11]) then
				found = false
-- print("u", aurainfo[1])
				addon['updateButton'](bar, aurainfo)
--				if(isSecure(bar,aurainfo)) then
					bar['auras'][aurainfo[11]] = aurainfo
--				end
				break
			end
		end
		if(found) then
-- print("r", currentaura[1])
			addon['remButton'](bar, currentaura)
		end
	end
	for aura, aurainfo in pairs(newauras) do
		found = false
		for currentaura in pairs(bar['auras']) do
			if(currentaura == aura) then
				found = true
				break
			end
		end
		if(not found) then
			if(not db[bar['name']]['spells'][aurainfo[11]]) then
				db[bar['name']]['spells'][aurainfo[11]] = {
					['blacklist'] = db[bar['name']]['whitelist'] or nil,
					['order'] = 100,
				}
				barprefs(bar)
			end
			if(bar['spells'][aurainfo[11]]['sticky']) then
				bar['auras'][aurainfo[11]] = aurainfo
--		print("u", aurainfo[1])
--				bar['auras'][aurainfo[11]][]
				addon['updateButton'](bar, aurainfo)
			else
				if(not bar['spells'][aurainfo[11]]['blacklist']) then
-- print("a", aurainfo[1])
					addon['addButton'](bar, aurainfo)
				end
			end
		end
	end
end

local function AddSticky(bar)
	bar['stickybuttons'] = 0
	bar['auras'] = bar['auras'] or {}
	bar['buttons'] = bar['buttons'] or {}
--	db[bar['name']] = db[bar['name']] or {
--		['spells'] = {},
--	}
-- name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3
	sort(db[bar['name']]['spells'], sortbyorder)
	for spell, spellInfo in pairs(db[bar['name']]['spells']) do
		if(spellInfo['sticky'] and not spellInfo['blacklist']) then
			local name, rank, icon = GetSpellInfo(spell)
			local aurainfo = {
				name, rank, icon, 0, "", 0, 0, 'player', false, false, spell, false,false,false,false,false,false,"HELPFUL",false,'player'
			}
--			print("add",name, rank, icon)
			addon['addButton'](bar, aurainfo)
			bar['stickybuttons'] = bar['stickybuttons'] + 1
		end
	end
	local x, y = 0,0
	local d = bar['reverse'] and -1 or 1
	for i = 1,#bar['buttons'] do
		local w, h = bar['buttons'][i]:GetWidth(),bar['buttons'][i]:GetHeight()
		bar['auras'][bar['buttons'][i]['aura'][11]] = bar['buttons'][i]['aura']
		bar['buttons'][i]:SetParent(bar['frame'])
		bar['buttons'][i]:SetPoint("CENTER",x*w*(bar['vertical'] and 1 or d),y*h*(bar['vertical'] and d or 1))
		bar['buttons'][i]:SetAttribute("type2", "cancelaura")
		bar['buttons'][i]:SetAttribute("type1", "spell")
		bar['buttons'][i]:SetAttribute("spell", bar['buttons'][i]['aura'][1])
		bar['buttons'][i]:SetAttribute("unit", "player")
		bar['buttons'][i]:RegisterForClicks("AnyUp")
		if(bar['vertical']) then
			y = y + 1
		else
			x = x + 1
		end
	end
end

local function updateAura(guid, auras, regname, bar)
-- name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3
--	print(guid,regname,bar['name'])
	local found
--	for _,bar in pairs(db) do
		for unit, unitinfo in pairs(bar['units']) do
			if(UnitGUID(unit) == guid) then
				for aura,aurainfo in pairs(unitinfo['auras']) do
					found = false
					for _, newAura in pairs(auras) do
						if(newAura[11] == aura) then
							found = true
							unitinfo['auras'][aura] = newAura
							break
						end
					end
					if(not found) then
--						print("-", unit, aura)
						unitinfo['auras'][aura] = nil
					end
				end
			end
		end
		for unit, unitinfo in pairs(bar['units']) do
			if(UnitGUID(unit) == guid) then
				for _, aura in pairs(auras) do
					if(aura[11] and ((aura[8] and addon['pguid'] == UnitGUID(aura[8])) or aura[12])) then
						found = true
						for oldAura in pairs(unitinfo['auras']) do
							if(oldAura == aura[11]) then
								found = false
								break
							end
						end
						if(found) then
--							print("+",unit,_,barName,regname,aura[1],aura[8],aura[11],GetSpellLink(aura[11]))
							unitinfo['auras'][aura[11]] = aura
						end
					end
				end
			end
		end
		barUpdate(bar)
--	end
end

local function updateUnit(bar, kill)
--	print("uu",bar['name'],kill)
	if(kill) then
		for aura, aurainfo in pairs(bar['auras']) do
			addon['remButton'](bar, aurainfo, kill)
		end
	end
	for unit,unitinfo in pairs(bar['units']) do
		unitinfo['auras'] = unitinfo['auras'] or {}
		local guid = UnitGUID(unit)
--		print(unit,guid)
		if(not guid) then
			wipe(unitinfo['auras'])
		elseif(unitinfo['guid'] ~= guid or kill) then
			if(kill) then
				wipe(unitinfo['auras'])
				AddSticky(bar)
			end
			unitinfo['regName'] = addon['registerAuraUpdate'](guid , function(guid, auras, regname) updateAura(guid, auras, regname, bar) end, unitinfo['regName'] or nil)
			addon['scanAura'](unit)
		end
	end
end

local function barsUpdate(prune, pruneunit)
	for barName, bar in pairs(db) do
		if(prune and bar['units'][pruneunit]) then
			for aura in pairs(bar['units'][pruneunit]['auras']) do
				bar['units'][pruneunit]['auras'][aura] = nil
			end
		end
		updateUnit(bar)
		barUpdate(bar)
	end
end

addon['barsUpdate'] = barsUpdate

local function killBar(bar)
	updateUnit(bar, true)
end

-- spellsettings

local function getPref3(pref)
	local spellId = gsub(pref[#pref - 1], "(.-) %((.-)%)|r","%2")
	return db[pref[#pref - 3]]['spells'][tonumber(spellId) and tonumber(spellId) or spellId][pref[#pref]]
end

local function setPref3(pref,value)
	local spellId = gsub(pref[#pref - 1], "(.-) %((.-)%)|r","%2")
	db[pref[#pref - 3]]['spells'][tonumber(spellId) and tonumber(spellId) or spellId][pref[#pref]] = value
	barprefs(db[pref[#pref - 3]])
	killBar(db[pref[#pref - 3]])
end
-- bar settings
local function getPref2(pref)
	return db[pref[#pref - 1]][pref[#pref]]
end

local function setPref2(pref,value)
	db[pref[#pref - 1]][pref[#pref]] = value
	barprefs(db[pref[#pref - 1]])
	killBar(db[pref[#pref - 1]])
end
-- whitelist/blacklist settings
local function getPref(pref)
	local res = addon['split'](pref[#pref],"-")
	return db[pref[#pref - 2]]['spells'][addon['sortbuttons'][res[1]] and res[1] or tonumber(res[1])]['blacklist']
end

local function setPref(pref,value)
	local res = addon['split'](pref[#pref],"-")
	db[pref[#pref - 2]]['spells'][addon['sortbuttons'][res[1]] and res[1] or tonumber(res[1])]['blacklist'] = value or nil
	barprefs(db[pref[#pref - 2]])
	killBar(db[pref[#pref - 2]])
end

local function deleteBL(pref)
	for k, v in pairs(db[pref[#pref - 2]]['spells']) do
		if(type(v) ~= 'table' or v['blacklist']) then
			db[pref[#pref - 2]]['spells'][k] = nil			
		end
	end
	barprefs(db[pref[#pref - 2]])
end

barprefs = function(bar) -- local, see dummy above
	local options = addon['options']['args'][name]
	local bp = addon['AddConfigMenu'](addon, {
		['name'] = bar['name'],
		['childGroups'] = 'tab',
		['menuGet'] = getPref2,
		['menuSet'] = setPref2,
	}, options)
	local wl = addon['AddConfigMenu'](addon, {
		['name'] = 'Whitelist',
		['childGroups'] = 'tab',
		['menuGet'] = getPref,
		['menuSet'] = setPref,
	}, bp)
	local bl = addon['AddConfigMenu'](addon, {
		['name'] = 'Blacklist',
		['childGroups'] = 'tab',
		['menuGet'] = getPref,
		['menuSet'] = setPref,
		['order'] = 2,
	}, bp)
	local ss = addon['AddConfigMenu'](addon, {
		['name'] = 'Spellsettings',
		['childGroups'] = 'tree',
		['menuGet'] = getPref,
		['menuSet'] = setPref,
		['order'] = 3,
	}, bp)
	local tools = addon['AddConfigMenu'](addon, {
		['name'] = 'Tools',
		['childGroups'] = 'tab',
		['menuGet'] = getPref,
		['menuSet'] = setPref,
		['order'] = 4,
	}, bp)
	addon['AddConfigEntry'](addon, name, 'toggle', 'whitelist', 'Blacklist', 'Add new spells to whitelist or blacklist', 1,nil,nil,nil,nil,bp)
	addon['AddConfigEntry'](addon, name, 'toggle', 'vertical', 'Vertical', 'Vertical or horizontal layout', 1,nil,nil,nil,nil,bp)
	addon['AddConfigEntry'](addon, name, 'toggle', 'reverse', 'Reverse', 'Growth direction', 1,nil,nil,nil,nil,bp)
	addon['AddConfigEntry'](addon, name, 'execute', 'delBL', "Delete Blacklist", "Remove all blacklisted spells from this bar.", 1,deleteBL,nil,nil,nil,tools)
--	addon['AddConfigEntry'](addon, name, 'execute', 'cleanDB', "CleanDB", "", 1,function() addon['Print'](addon) end,nil,nil,nil,tools)
	
	for spellId, spellInfo in pairs(bar['spells']) do
--		if(spellId==0) then bar['spells'][spellId] = nil end
		local spell = "dummy"
		if(addon['sortbuttons'][spellId]) then
			spell = spellId
		else
			spell = GetSpellInfo(spellId)
		end
		if(spell) then
			addon['AddConfigEntry'](addon, name, 'toggle', spellId.."-"..spell, spell, nil, 1,nil,nil,nil,nil,spellInfo['blacklist'] and bl or wl)
			local si = addon['AddConfigMenu'](addon, {
				['name'] = addon['colorize'](spell .. " ("..spellId..")", spellInfo['blacklist'] and "ffffff" or "00ff00"),
--				['name'] = spell .. " ("..spellId..")",
				['childGroups'] = 'tab',
				['menuGet'] = getPref3,
				['menuSet'] = setPref3,
				['order'] = db[bar['name']]['spells']['order'] or 100,
			}, ss)
			addon['AddConfigEntry'](addon, name, 'toggle', "sticky", "Sticky", "Sticky means visible all the time sorted by order. This allows to cast a spell or cancel this aura in combat.", 1,nil,nil,nil,nil,si)
			addon['AddConfigEntry'](addon, name, 'range', "order", "Order", "Used for sort by order", 1,1,100,1,false,si)
		end
	end
end

local function sortbyorder(a,b)
	return a['order']<b['order']
end



local function dragAble()
	return addon['db']['profile']['dragAble']
end

addon['preloads'][#addon['preloads'] + 1] = function ()
	addon['db']['profile']['bars'] = addon['db']['profile']['bars'] or bars
	db = addon['db']['profile']['bars']

	for barName, bar in pairs(db) do
		bar['frame'] = CreateFrame("Frame", name..barName, UIParent)
		bar['frame']:SetWidth(32)
		bar['frame']:SetHeight(32)
		bar['frame']['db'] = db[barName]
		bar['frame']['dragAble'] = dragAble
		bar['frame']:SetPoint("CENTER")
		addon['barprefs'][#addon['barprefs'] + 1] = function() barprefs(bar) end
		addon['AddDrag'](bar['frame'],"BOX",{
			['width'] = 64,
			['height'] = 64,
			['anchor'] = "BOTTOMLEFT",
			['parentanchor'] = "TOPLEFT",
			['xOffset'] = 0,
			['yOffset'] = 0,
			['offset'] = 16,
		})
		AddSticky(bar)
	end
end

addon['inits'][#addon['inits'] + 1]  = function()
	addon['RegisterFunc']({"PLAYER_FOCUS_CHANGED","PLAYER_TARGET_CHANGED", "PLAYER_ENTERING_WORLD"},"OnEvent",function(self,event)
		local unit = event == "PLAYER_TARGET_CHANGED" and "target" or "focus"
		barsUpdate(not UnitExists(unit), unit)
		addon['scanAura'](unit)
	end)
end

addon['logouts'][#addon['logouts'] + 1] = function()
	local cnt,def,keep = 0,2,false
	for barName, bar in pairs(db) do
		for spell, spellInfo in pairs(db[barName]['spells']) do
			cnt = 0
			keep = true
			for k, v in pairs(spellInfo) do
				cnt = cnt + 1
			end
--			if(spellInfo['order'] == 100 and (bit.bxor(spellInfo['blacklist'],db[barName]['whitelist']))) then
--				keep = false
--			end
			if(cnt == 0) then
				keep = false
			end
			if(not keep) then
				db[barName]['spells'][spell] = nil
			end
		end
--		bar['frame']:UserPlaced(true)
		db[barName]['buttons'] = nil
		db[barName]['auras'] = nil
		db[barName]["stickybuttons"] = nil
		db[barName]["frame"] = nil
		db[barName]["frame"] = nil
		
		for k, v in pairs(db[barName]['units']) do
			wipe(db[barName]['units'][k]['auras'])
			db[barName]['units'][k]['guid'] = nil
			db[barName]['units'][k]['regName'] = nil
		end
--		bar['frame']:UserPlaced(true)
--		barprefs(bar)
	end
end